/*
 * $Header: /Book/AutoComReference.h 3     3.07.99 17:46 Oslph312 $
 */

#pragma once

#include "Exception.h"


template< class T >
class AutoComReference {
private:
   T *m_pComReference;

public:
   explicit AutoComReference( void );
// explicit AutoComReference( T *pComReference );
   explicit AutoComReference( REFCLSID rclsid, REFIID riid );
   explicit AutoComReference( REFIID riid, IUnknown *pComReference );
   ~AutoComReference();
   T* operator->() throw();
   operator T*() throw();
   T** operator &() throw();
};


template< class T >
inline AutoComReference< T >::AutoComReference( void ) 
   : m_pComReference( 0 )
{
}


#if 0
template< class T >
inline AutoComReference< T >::AutoComReference( T *pComReference ) 
   : m_pComReference( pComReference )
{
}
#endif


template< class T >
inline AutoComReference< T >::AutoComReference< T >( 
   REFCLSID rclsid, REFIID riid ) : m_pComReference( 0 )
{
   HRESULT hres = CoCreateInstance( rclsid, 0, 
      CLSCTX_INPROC_SERVER, riid, (LPVOID *) &m_pComReference );
   if ( !SUCCEEDED( hres ) ) {
      throw ComException( hres );
   }
}


template< class T >
inline AutoComReference< T >::AutoComReference< T >( 
   REFIID riid, IUnknown *pComReference ) : m_pComReference( 0 )
{
   assert( 0 != pComReference );
   HRESULT hres = pComReference->QueryInterface( 
      riid, (LPVOID *) &m_pComReference );
   if ( !SUCCEEDED( hres ) ) {
      throw ComException( hres );
   }
}


template< class T >
inline AutoComReference< T >::~AutoComReference< T >() {
   assert( 0 != m_pComReference );
   if ( 0 != m_pComReference ) {
#ifdef _DEBUG
      const ULONG ulRefCount = 
#endif
         m_pComReference->Release();

      reset_pointer( m_pComReference );
      unused( ulRefCount );
   }
}


template< class T >
inline T* AutoComReference< T >::operator->() throw() {
   return m_pComReference;
}


template< class T >
inline AutoComReference< T >::operator T*() throw() {
   return m_pComReference;
}


template< class T >
inline T** AutoComReference< T >::operator &() throw() {
   return &m_pComReference;
}

// end of file
