/*
 * $Header: /Book/AutoHandle.h 7     6-09-01 12:37 Oslph312 $
 *
 * HINT: To see the handle wrapped by AutoHandle during Visual C++
 * debugging, add the following line to the AUTOEXP.DAT file:
 * AutoHandle<*>=<m_handle>
 */

#pragma once


class AutoHandle {
private:
   HANDLE m_handle;

public:
   explicit AutoHandle( HANDLE handle = 0 );
   ~AutoHandle();
   HANDLE operator=( HANDLE handle );
   operator HANDLE();
};


inline AutoHandle::AutoHandle( HANDLE handle ) : m_handle( handle ) {
}


inline AutoHandle::~AutoHandle() {
   if ( 0 != m_handle && INVALID_HANDLE_VALUE != m_handle ) {
      verify( CloseHandle( m_handle ) );
   }
}

inline HANDLE AutoHandle::operator=( HANDLE handle ) {

#ifdef _DEBUG
   if ( INVALID_HANDLE_VALUE != m_handle && 0 != m_handle ) {
#ifdef trace
      trace( _T( "Suspect AutoHandle assignment -- will this ever be closed?" ) );
#endif
      DebugBreak();
   }
#endif

   m_handle = handle;
   return m_handle;
}

inline AutoHandle::operator HANDLE() {
   return m_handle;
}

// end of file
