/*
 * $Header: /Book/AutoShellObject.h 6     6.11.01 11:34 Oslph312 $
 *
 * Automatic destruction for object references needing comFree.
 */

#pragma once

#include "utils.h"


template< class T >
class AutoShellObject {
private:
   T *_pShellObject;

public:
   explicit AutoShellObject( T* pShellObject = 0 );
   ~AutoShellObject();
   operator T*() throw();
   T** operator &() throw();
   bool isNull( void ) const;
};


template< class T >
inline AutoShellObject< T >::AutoShellObject( T* pShellObject ) 
   : _pShellObject( pShellObject )
{
}


template< class T >
inline AutoShellObject< T >::~AutoShellObject< T >() {
   if ( 0 != _pShellObject ) {
      comFree( _pShellObject );
   }
}


template< class T >
inline AutoShellObject< T >::operator T*() throw() {
   return _pShellObject;
}


template< class T >
inline T** AutoShellObject< T >::operator &() throw() {
   return &_pShellObject;
}


template< class T >
inline bool AutoShellObject< T >::isNull( void ) const throw() {
   return 0 == _pShellObject;
}

// end of file
