/*
 * $Header: /scr_test/ClientDC.h 5     11.07.01 14:33 Oslph312 $
 */

#pragma once


#ifndef verify
#define verify( X ) ( X )
#endif


class ClientDC {

private:
   HDC  m_hdc ;
   HWND m_hwnd;
   
public:
   explicit ClientDC ( HWND hwnd = HWND_DESKTOP );
   ~ClientDC ( void );
   bool isValid( void ) const;
   operator HDC() const;
};


inline ClientDC::ClientDC ( HWND hwnd ) : m_hwnd( hwnd ) {

#ifdef assert
   assert( HWND_DESKTOP == m_hwnd || IsWindow( m_hwnd ) );
#endif

   m_hdc = GetDC( m_hwnd );
   if ( !isValid() ) {
#ifdef trace
      trace( _T( "ClientDC: GetDC( %#x ) failed: %lu\n" ), 
         m_hwnd, GetLastError() );
#endif
   }
}


inline ClientDC::~ClientDC ( void ) {

#ifdef assert
   assert( HWND_DESKTOP == m_hwnd || IsWindow( m_hwnd ) );
#endif

   if ( 0 != m_hdc ) {
      verify( ReleaseDC( m_hwnd, m_hdc ) );
   }
}


inline bool ClientDC::isValid( void ) const {

   assert( HWND_DESKTOP == m_hwnd || IsWindow( m_hwnd ) );
   return 0 != m_hdc;
}


inline ClientDC::operator HDC() const {

   assert( HWND_DESKTOP == m_hwnd || IsWindow( m_hwnd ) );
   return m_hdc;
}

// end of file
