/*
 * $Header: /Book/RegRename.cpp 2     5.03.02 10:05 Oslph312 $
 *
 * This code was posted to UseNet by Ahmed Kandeel.
 * He originally found it on http://www.frogpond.org/~markg/article/renreg.html,
 * but that link appears to be dead.
 *
 * TODO: This code could definitely stand some cleaning up.
 */

#include "precomp.h"


BOOL copyRegistryKey( HKEY hFrom, HKEY hTo ) {

    char *pszValueName = (char *) GlobalAllocPtr( GHND, 8192 );      //  Need some buffer space
    if ( 0 == pszValueName ) {
        return FALSE;
    }

    BYTE *pbBuffer = (BYTE *) pszValueName + 512;

    LONG lStatus = ERROR_SUCCESS;
    int iKey = 0;                                            //  Start with value #0
    do {
        DWORD dwType;
        DWORD dwValueSize = 512;                //  Tell system how much buffer we have
        DWORD dwBufferSize = 8192 - 512;
        //  and enumerate data values at current key
        lStatus = RegEnumValue( hFrom, iKey, pszValueName, &dwValueSize,
            NULL, &dwType, pbBuffer, &dwBufferSize );

        if ( ERROR_SUCCESS == lStatus )           //  Move each value to new place
        {
            lStatus = RegSetValueEx( hTo, pszValueName, 0, dwType,
                pbBuffer, dwBufferSize );
            RegDeleteValue( hFrom, pszValueName );            //  Delete old value
        }
    }
    while ( ERROR_SUCCESS == lStatus );           //  Loop until all values found

    iKey = 0;             //  Start over, looking for keys now instead of values
    do {
        HKEY hNewTo, hNewFrom;
        DWORD dwValueSize = 512;                  //  Tell system about the buffer size
        DWORD dwBufferSize = 8192 - 512;

        //  Get "next" key
        lStatus = RegEnumKeyEx( hFrom, iKey, pszValueName, &dwValueSize,
            NULL, (char *) pbBuffer, &dwBufferSize, NULL );
        if ( ERROR_SUCCESS == lStatus )                 //  Was a valid key found?
        {                                               //  Open the key if found
            lStatus = RegCreateKey( hTo, pszValueName, &hNewTo );
            if ( ERROR_SUCCESS == lStatus )             //  If the key opened...
            {                                           //  Create new key of old name
                lStatus = RegCreateKey( hFrom, pszValueName, &hNewFrom );
                if ( ERROR_SUCCESS == lStatus )
                {                             //  If that worked, recurse back here
                    copyRegistryKey( hNewFrom, hNewTo );    //  to "walk the tree"
                    RegCloseKey( hNewFrom );                //  Close each new key
                    RegDeleteKey( hFrom, pszValueName );    //  Delete old key
                }
                RegCloseKey( hNewTo );                      //  Close each old key
            }
        }
    } while ( ERROR_SUCCESS == lStatus );   //  Loop until key enum fails

    GlobalFreePtr( pszValueName );
    return TRUE;
}


//  This assumes HKEY_CURRENT_USER, so nothing *drastic* happens.
BOOL renameRegistryItem( LPCTSTR from, LPCTSTR to ) {

    // Open "from" key; fail if it doesnt' open
    HKEY hkeyFrom = 0;
    LONG lStatus = RegOpenKey( HKEY_CURRENT_USER, from, &hkeyFrom );
    if ( ERROR_SUCCESS != lStatus ) {
        return FALSE;
    }

    // Open "to" key; fail if it doesnt' open
    HKEY hkeyTo = 0;
    lStatus = RegCreateKey( HKEY_CURRENT_USER, to, &hkeyTo );
    if ( ERROR_SUCCESS != lStatus ) {
        RegCloseKey( hkeyFrom ); // TODO: Wrapper class to close
        return FALSE;
    }

    BOOL status = copyRegistryKey( hkeyFrom, hkeyTo );

    RegCloseKey( hkeyTo );
    RegCloseKey( hkeyFrom );
    RegDeleteKey( HKEY_CURRENT_USER, from );  //  Delete last top-level key

    return status;
}

// end of file
